<template>
  <div id="messenger">
    <div class="show-massages" v-for="(message, index) in messages" :key="index">
      <ShowMessages class="massage" :message="message" :idActualUser="idActualUser" />
    </div>

    <SendMessages @send-new-message-event="sendMessage" />
  </div>
</template>

<script>
import SendMessages from './SendMessages.vue'
import ShowMessages from './ShowMessages.vue'

import API from '@/API.js'
export default {
  name: 'MessengerPage',
  components: {
    SendMessages,
    ShowMessages
  },
  props: {},

  data() {
    return {
      messages: null,

      idActualUser: this.$route.params.idActualUser,
      idSearchedUser: this.$route.params.id_user,
      actualUserRole: '',

      idReceiver: '',
      idSender: '',
      intervalId: null
    }
  },

  async mounted() {
    let idActualUser = this.idActualUser
    this.actualUserRole = await API.getIdActualUser(this.idActualUser)

    if (this.actualUserRole.role === 'normal') {
      this.messages = await API.getAllMessages(idActualUser)
    } else {
      this.messages = await API.getAllMessages(this.idSearchedUser)
    }

    if (this.actualUserRole.role === 'normal') {
      this.idReceiver = '2'
      this.idSender = this.idActualUser
    } else {
      this.idReceiver = this.idSearchedUser
      this.idSender = '2'
    }

    this.intervalId = setInterval(this.getAllMessages, 5000)
  },

  methods: {
    async getAllMessages() {
      let idActualUser = this.idActualUser

      if (this.actualUserRole.role === 'normal') {
        this.messages = await API.getAllMessages(idActualUser)
      } else {
        this.messages = await API.getAllMessages(this.idSearchedUser)
      }

      //this.messages = await API.getAllMessages(idActualUser);
    },

    async sendMessage(message) {
      let idReceiver = this.idReceiver
      let idSender = this.idSender
      let idActualUser = this.idActualUser
      await API.sendMessage(message, idSender, idReceiver)
      this.messages = await API.getAllMessages(idActualUser)
    }
  },
  beforeDestroy() {
    clearInterval(this.intervalId)
  }
}
</script>


<style scoped>
#product_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
}
</style>
